/**
 * Copyright (c) 2020 ~ 2021 KylinSec Co., Ltd.
 * lightdm-kiran-greeter is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 *
 * Author:     liuxinhao <liuxinhao@kylinos.com.cn>
 */

#ifndef GREETERKEYBOARD_H
#define GREETERKEYBOARD_H

#include <QObject>
#include <QProcess>

class GreeterKeyboard : public QObject
{
    Q_OBJECT
public:
    static GreeterKeyboard *instance();
    ~GreeterKeyboard();

    bool     init(QWidget *parent = nullptr);
    void     hide();
    bool     isVisible();
    void     showAdjustSize(QWidget *parent = nullptr);
    QWidget *getKeyboard();
    void     keyboardProcessExit();

public slots:
    void slot_finished(int exitCode, QProcess::ExitStatus exitStatus);

private:
    explicit GreeterKeyboard(QObject *parent = nullptr);

private slots:
    void slotReadyReadStandardOutput();

private:
    QWidget * m_keyboardWidget;
    QProcess *m_process;
};

#endif  // GREETERKEYBOARD_H
